#include <stdio.h>
#include <string>
#include <iostream.h>
#include <fstream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include "htnews.h"


string SENDER;

int main(int argc, char* argv[])
{
	/*
	 * here we will start everytime, so let's create and open
	 * the pidfile at this point
	 * in the function Exit() we will close it!
	 */
	pid_t pid;
	ofstream PID("/var/run/htnews.pid");
	lock(PID);
	PID << pid << endl;

	// define some vars
	string ADMIN, TO, CC, AUTH_CODE, INPUT, Message, COMP;
	string FROM, SUBJECT, Allow_From, SPAMPROTECT;
	string TEMPLATE, OUTPUT, HEAD(""), ITEM_HEAD(""), ITEM_FOOT(""), STORE(""); 
	string FieldOrder[4], Mailto, Date_HEAD, Date_FOOT;
	string Subject_HEAD, Subject_FOOT, From_HEAD, From_FOOT;
	string Text_HEAD, Text_FOOT,Cron_TEMPLATE, Cron_OUTPATH, Cron_OUTPUT, Cron_HEAD, Cron_FOOT, Cron_Hist;
	string CronLinks("default");
	int HaveCron=0;
	string ARCHIV, Archiv_STORE, Archiv_TEMP, Archiv_OUTPUT, Archiv_TEMPLATE, Archiv_MAXITEMS;
	string Archiv_Title_Head, Archiv_Title_Foot;
	int MAXITEMS, NumItems=0, UseHTML=0, doitnot=0,IsHTML=0;

	string line("");
	string parse_config, Orig_MSG("/tmp/htnews.orig");
	string CMD(""),err_msg; 
	string UseSubject(""), UseFrom(""), UseDate(""), buffer, S("");
        int refresh=0, yes=1, u=0, c=0, cou=0, match=0, MAX=50, _true=0, body=0, st=0, i=0;
	char TMP[MAX], zeichen;
	string::size_type _pos,head_,_head;
	int Pipe_Lines=400, FieldMax, HaveText=0; 
        string argh[Pipe_Lines]; 
        int mypipe[2]; 
	ofstream MSG_FILE("/tmp/htnews.msg");
	ofstream *Detail;
	string htnews_marker[2];
	htnews_marker[0] = "<!htnews"; // for backward compatibility
	htnews_marker[1] = "<!--htnews-->"; // the NEW marker
	string archiv_marker[2];
	archiv_marker[0] = "<!archiv"; // for backward compatibility
	archiv_marker[1] = "<!--archiv-->"; // the NEW marker
	string cron_marker("<!--cron-->"); // marker for cronmode links
	string Temp(""), bound(""), Month,Year, CRLF("");
	int quoted=0, cron=0;	

	string T(""), NewAString(""), head("");
	string DetailMSG(""), MessageID(""),DetailName("");
	int LookDetail=0, HaveDetail=0;	
	string DetailPATH(""), DetailLink(""), DetailURL(""), SimpleSubject("");
	string DetailTemplate(""), Detail_HEAD, Detail_FOOT;
	ifstream Detail_Templ;


	enum
	{
        realname,
        adress,
        subject,
	date,
	messageid,
        message
	};


	enum { sender,admin,to,cc,allow_from,auth_code,_Template,output,store, use_html, crlf, item_head,item_foot,field1,field2,field3,field4,mailto,date_head,date_foot,subject_head,subject_foot,from_head,from_foot,text_head,text_foot,spamprotect,archiv, archiv_output, archiv_template, archiv_store, archiv_maxitems, archivtitlehead, archivtitlefoot, cron_template, cron_outpath, cronhist, cronhead, cronfoot, lookdetail, detailtemplate, detailpath, detaillink, detailurl, detailhead, detailfoot};

	int NumParams=46;
	string params[NumParams][2];	
	string it;

	// validate commandline options:
	pr("parse commandline options");
	if(argc <= 1)
	{
		parse_config = "/etc/htnews.conf";
	}
	else
	{
		if((string(argv[1]) == "-c") && (string(argv[2]) != ""))
			parse_config = argv[2];
		else if((string(argv[1]) == "-a") && (string(argv[2]) != ""))
                {
                        cron = yes;
			parse_config = argv[2];
		}
		else if((string(argv[1]) == "-v") || (string(argv[1]) == "--version"))
		{
			cout << "htnews. Version " << string(VERSION) << endl;
			Exit();
		}
		else
		{ 
			cout << argv[0] << ": " << endl;error();
		}
	}
 
	// Set names of parameters...
	params[sender][0] = "SENDERsmtp";
	params[admin][0] = "ADMIN";
	params[to][0] = "TOsmtp";
	params[cc][0] = "CCsmtp";
	params[allow_from][0] = "Allow_From";
	params[auth_code][0] = "AUTH_CODE";
	params[_Template][0] = "TEMPLATE";
	params[output][0] = "OUTPUT";
	params[store][0] = "STORE";
	params[use_html][0] = "UseHTML";
	params[crlf][0] = "CRLF";
	params[item_head][0] = "ITEM_HEAD";
	params[item_foot][0] = "ITEM_FOOT";
	params[field1][0] = "Field1";
	params[field2][0] = "Field2";
	params[field3][0] = "Field3";
	params[field4][0] = "Field4";
	params[mailto][0] = "Mailto";
	params[date_head][0] = "Date_HEAD";
	params[date_foot][0] = "Date_FOOT";
	params[subject_head][0] = "Subject_HEAD";
	params[subject_foot][0] = "Subject_FOOT";
	params[from_head][0] = "From_HEAD";
	params[from_foot][0] = "From_FOOT";
	params[text_head][0] = "Text_HEAD";
	params[text_foot][0] = "Text_FOOT";
	params[spamprotect][0] = "SPAMPROTECT";
	params[archiv][0] = "ARCHIV";
	params[archiv_output][0] = "Archiv_Output";
	params[archiv_template][0] = "Archiv_Template";
	params[archiv_store][0] = "Archiv_Store";
	params[archiv_maxitems][0] = "Archiv_MAXITEMS";
	params[archivtitlehead][0] = "Archiv_Title_Head";
	params[archivtitlefoot][0] = "Archiv_Title_Foot";
	params[cron_template][0] = "Cron_TEMPL";
	params[cron_outpath][0] = "Cron_OUTPATH";
	params[cronhist][0] = "Cron_Hist";
	params[cronhead][0] = "Cron_HEAD";
	params[cronfoot][0] = "Cron_FOOT";

	params[lookdetail][0] = "LookDetail";
	params[detailtemplate][0] = "Detail_TEMPL";
	params[detailpath][0] = "Detail_PATH";
	params[detaillink][0] = "Detail_LINK";
	params[detailurl][0]  = "DetailURL";
	params[detailhead][0] = "Detail_HEAD";
	params[detailfoot][0] = "Detail_FOOT";

	pr("try to open the configfile");
	// get the config
	ifstream conf(parse_config.c_str());
	if( ! conf )
	{
		// the file doesn't exist or we cannot read it :-(
                cerr << "Error: Could not read " << parse_config << ".\n";
                Exit();
	}
	else
	{
		pr("read the configfile");
		while(conf)
		{
			conf.get(zeichen);
			if((zeichen == '\n'))
                        {
				if((buffer[0] != '#') && (buffer != ""))
				{
					for(int num=0;num<NumParams;num++)
					{
						it = getval(buffer, params[num][0]);
						if(it != "")
						{
							//cout << "getting value for: " << params[num][0] << ": " << it << endl;
							params[num][1] = it;
							it = "";
							break;
						}	
					}
				}
				buffer = "";
                        }
                        else
                                buffer += zeichen;
		}
	}	

	// now we have all stuff temp. stored in
	// params[][]. Now check them and assign to the real used vars...
	// who should get error mails?

	pr("parse the options from the config");
        ADMIN = params[admin][1];
        if(ADMIN == "")
        {
               ADMIN = _DEFAULTADMIN;
        }

	// who we are?
        SENDER = params[sender][1];
        if(SENDER == "")
        {
               err("Standard","Error: Could not find a value for \"SENDER\" in " + parse_config + ".\n", ADMIN);
        }


	// receipient of success messages?
	TO = params[to][1];
	if(TO == "")
        {
		TO = ".mailfrom";// send it back to originator!(parsed later)
        }
	
	// Carbon Copy to someone? If not found, then no CC.	
	CC = params[cc][1];
	
	Allow_From = params[allow_from][1];
	if(Allow_From == "")
        {
		Allow_From = ".everybody"; // no allow_from file specified, so everybody can use it!
        }

	AUTH_CODE = params[auth_code][1];
	if(AUTH_CODE == "")
	{
		AUTH_CODE = ""; // If not specified, no Authcode needed.
	}
	else
	{
		AUTH_CODE.append(" ");// only a subject with a space after the code will be accepted!
	}

	// which template to use?
	TEMPLATE = params[_Template][1];
	if(TEMPLATE == "")
	{
		err("Standard","Error: Could not find a value for \"TEMPLATE\" in " + parse_config + ".\n", ADMIN);
	}
	
	// where to write the output?
	OUTPUT = params[output][1];
	if(OUTPUT == "")
        {
                err("Standard","Error: Could not find a value for \"OUTPUT\" in " + parse_config + ".\n", ADMIN);
        }

	// where to store old news?
	STORE = params[store][1];
	if(STORE == "")
	{
		err("Standard","Error: Could not find a value for \"STORE\" in " + parse_config + ".\n", ADMIN);
	}

	// use the html-part of a mail?
	if(params[use_html][1] == "YES")
		UseHTML = yes;
	else
		UseHTML = 0;

	if(params[crlf][1] == "YES")
		CRLF = "YES";
	

	// Optional parameters for formatting an item and some fields
	ITEM_HEAD = params[item_head][1];
	ITEM_FOOT = params[item_foot][1];
	
	for(st=0;st<4;st++)
	{
		switch(st)
		{
			case 0: FieldOrder[st] = params[field1][1]; break;
			case 1: FieldOrder[st] = params[field2][1]; break;
			case 2: FieldOrder[st] = params[field3][1]; break;
			case 3: FieldOrder[st] = params[field4][1]; break;
			default: break;
		}
		if(FieldOrder[st] == "")
		{
			if(st < 1)
				err("Standard","Error: At least one field is required!", ADMIN);
			else
				break;
		}
		else if(FieldOrder[st] == "Text")
			HaveText = 1;
	}
	FieldMax = st;
	if(HaveText !=1)
		err("Standard","Error: The field \"Text\" in field order is required!", ADMIN);
	
	Mailto = params[mailto][1];
	Date_HEAD = params[date_head][1];
	Date_FOOT = params[date_foot][1];
	Subject_HEAD = params[subject_head][1];
	Subject_FOOT = params[subject_foot][1];
	From_HEAD = params[from_head][1];
	From_FOOT = params[from_foot][1];
	Text_HEAD = params[text_head][1];	
	Text_FOOT = params[text_foot][1];	
	SPAMPROTECT = params[spamprotect][1];	
	Cron_TEMPLATE = params[cron_template][1];
	Cron_OUTPATH = params[cron_outpath][1];
	Cron_Hist = params[cronhist][1];
	Cron_HEAD = params[cronhead][1];
	Cron_FOOT = params[cronfoot][1];

	if(params[lookdetail][1] == "YES")
	{
		LookDetail = yes;
		DetailPATH = params[detailpath][1];
		if(DetailPATH == "")
		{
			err("Standard","Error: Could not find a value for \"DetailPATH\" in " + parse_config +".\n",ADMIN);
		}
		DetailTemplate = params[detailtemplate][1];
		if(DetailTemplate == "")
		{
			err("Standard","Error: Could not find a value for \"DetailTempl\" in " + parse_config +".\n",ADMIN);
		}
		Detail_Templ.open(DetailTemplate.c_str());
		if( ! Detail_Templ )
		{
			err("Standard","Error: Could not open \"" + DetailTemplate + "\"\n", ADMIN);
		}
		else
			Detail_Templ.close();
		DetailLink = params[detaillink][1];
		DetailURL = params[detailurl][1];
		if(DetailURL != "")
		{
			int dl = DetailURL.length();
			// add a / to the URL if not still there
			if(DetailURL[dl] != '/')
				DetailURL += "/";
		}
		Detail_HEAD = params[detailhead][1];
		Detail_FOOT = params[detailfoot][1];
	}

	if(cron == yes)
	{
		time_t z;
                time(&z);
                string Z, UZ;
                Z = ctime(&z);
		int zpos=0;
		/*
		 * obsolete, use assign instead.
		#if defined _EGCS
                	UZ = Z.erase(24);
                #else  
                        UZ = Z.remove(24);
                #endif
		*/
		int Zlen = Z.length();
		UZ.assign(Z, 0, Zlen-1);
		
		int zlen = UZ.length();
		for(i=0;i<zlen;i++)
		{
			if((UZ[i] == ' ') && (zpos == 0))
			{
				zpos = 1;
			}
			else if((UZ[i] != ' ') && (zpos == 1))
			{
				Month += UZ[i];
			}
			else if((UZ[i] == ' ') && (zpos == 1))
				break;
		}
		Year.assign(UZ, zlen - 4);
		Month += "_" + Year;
		pr("Month: " + Month);
		Cron_OUTPUT = Cron_OUTPATH + "/" + Month + ".html";

		if(Cron_Hist == "")
		{
			err("Standard","Error: Could not find a value for \"Cron_Hist\" in " + parse_config + ".\n", ADMIN);
		}
	}
	fstream HistoryIn;
	ofstream HistoryOut;
	if((cron == yes) || (ARCHIV == "YES"))
	{
		HistoryIn.open(Cron_Hist.c_str(), ios::out | ios::in);
		if(! HistoryIn)
		{
			err("Standard", "Error: Could not open " + Cron_Hist + "\n", ADMIN);
		}
		else
			HistoryIn.close();
	}

	ARCHIV = params[archiv][1];
	if(ARCHIV == "YES")
	{
		Archiv_OUTPUT = params[archiv_output][1];
		if(Archiv_OUTPUT == "")
		{
			err("Standard","Error: Could not find a value for \"Archiv_OUTPUT\" in "
				+ parse_config + ".\n", ADMIN);
		}
		Archiv_TEMPLATE = params[archiv_template][1];
		if(Archiv_TEMPLATE =="")
		{
			err("Standard","Error: Could not find a value for \"Archiv_TEMPLATE\" in "
				+ parse_config + ".\n", ADMIN);
		}		
	
		Archiv_STORE = params[archiv_store][1];
		if(Archiv_STORE == "")
		{
			err("Standard","Error: Could not find a value for \"Archiv_STORE\" in "
				+ parse_config + ".\n", ADMIN);
		}
	
		Archiv_MAXITEMS = params[archiv_maxitems][1];
		if(Archiv_MAXITEMS == "")
			MAXITEMS = 10; // the default!
		else
			MAXITEMS = atoi(Archiv_MAXITEMS.c_str());

		Archiv_TEMP = "/tmp/htnews.archiv.tmp";
		
		Archiv_Title_Head = params[archivtitlehead][1];
		Archiv_Title_Foot = params[archivtitlefoot][1];

	}
	else
	{
		if(cron == yes)
		{
			cout << "Error: ARCHIV is not enabled. -a not usefull in this mode. Exiting.\n";
			Exit();
		}	
		ARCHIV = "NO";
	}

	// *********************** have it all. start processing...

	pr("try to open some required files");
	ifstream Template(TEMPLATE.c_str());
	fstream Store;
	ifstream ReStore(STORE.c_str());

	ofstream Archiv_Temp(Archiv_TEMP.c_str());
	ifstream Archiv_ReStore(Archiv_STORE.c_str());
	ifstream Archiv_Template;
	if(cron != yes)
		Archiv_Template.open(Archiv_TEMPLATE.c_str());
	else
		Archiv_Template.open(Cron_TEMPLATE.c_str());

	fstream Archiv_Store;

	// check if we can open some filez...
	if( ! Template )
		err("Standard", "Error: Could not open " + TEMPLATE + "\n", ADMIN);
	if( ! MSG_FILE )
                err("Standard", "Error: Could not open temorary file!\n", ADMIN);

	if(ARCHIV == "YES")
	{
		if( ! Archiv_ReStore )
			err("Standard", "Error: Could not open " + Archiv_STORE + "\n", ADMIN);
		if( ! Archiv_Temp )
			err("Standard", "Error: Could not open " + Archiv_TEMP + "\n", ADMIN);
		if( ! Archiv_Template )
			err("Standard", "Error: Could not open " + Archiv_TEMPLATE + "\n", ADMIN);
	}
	






	// generic stuff done at this point!

     if(cron != yes)
     {





	pr("try to open the pipe");
        // open the Pipe and get the Message:
        if(pipe(mypipe))
        {
                err("Standard", "Error: Could not open Pipe [stdin]\n", ADMIN);
        }
        cou = 0;
	pr("read data from pipe");
        FILE *stream;
        stream = fdopen(0, "r");
        while((c = fgetc(stream)) != EOF)
        {
                if(c == '\n')
                {
                        cou++;
                }
		else if(c == '`')
		{
			// SECURITY:
			// With this character enabled, someone
			// could execute something while htnews
			// calls sendmail to send a response mail.
			// i.e.: `cat /etc/passwd` in the message body!
			// So, a ` will be replaced with '!
			argh[cou] += char(39);
		}
                else
                {
                        argh[cou] += char(c);
                }
        }
        fclose(stream);

        // store the original Message, if we must send it back
        ofstream Orig(Orig_MSG.c_str());
        for(c=0;c<cou;c++)
                Orig << argh[c] << endl;



	// now let's parse argh[cou] (cou stores the number of lines we have.)
	c=0;
	pr("parse the message"); 
	while( c<cou )
	{
		INPUT = argh[c];
		if(match != 2 && body == 0)
		{
			// cout << argh[c] << endl;
			_pos = INPUT.find("boundary=");
			if( _pos != string::npos )
			{
				pr("boundary found");
				Temp.assign(INPUT, _pos+10);
				u = Temp.length();	
				for(i=0;i<u;i++)
				{
					if((Temp[i] != '-') && (Temp[i] != '"'))
						bound += Temp[i];
				}
			}
			
			// look for Message ID
			_pos = INPUT.find("Message-I");
			if( _pos != string::npos )
			{
				pr("Message-ID found");
				Temp.assign(INPUT, _pos+14);
				u = Temp.length();
				for(i=0;i<u;i++)
				{
					// save the messageID for a unique filename,
					// if the mail body contains a "detail:" 
					// It will look like this: "99032616241601.11413" and ".html" will be appended!
					if(Temp[i] != '@')
						MessageID += Temp[i];
					else if((Temp[i] == '$') || (Temp[i] == '*') || (Temp[i] == '%'))
						MessageID += 'O';
					else
						break;
				}
			}
			
			// look for quoted-printable formatting in the mail header.
			_pos = INPUT.find("quoted-printable");
			if(_pos != string::npos )
			{
				// look for "Autoconverted from 7bit to quoted-printable..." line, OUTLOOK!
				_pos = INPUT.find("Autoconverted");
				if(_pos != string::npos )
					bound = "";
				else
					bound = yes;
			}		
	
			_pos = INPUT.find("From:");
			if( _pos != string::npos )
			{	
				pr("From: found");
				if(INPUT.length() <= 5)
				 {
                                        // TMP is empty
					err(Orig_MSG, " Was the From: Line empty?\n", ADMIN);
                                }
				else
				{
						FROM.assign(INPUT, _pos+5);
				}
			}
                	if(match != 1)
			{
				_pos = INPUT.find("Subject:");
                		if( _pos != string::npos )
                		{
					pr("Subject: found");
                        		if(INPUT.length() <= 9)
                        	        {
                        	                // TMP is empty
                        	                err(Orig_MSG,"Error: Was the Subject: Line empty?\n",ADMIN);
                        	        }
					else
					{
                        	        	        SUBJECT.assign(INPUT, _pos+8);
							match = 1;
                        		}
                		}
			}
			string check("");
			check += "-" + INPUT + "-";
			if(check == "--")
			{
				body = 1;
				match = 2;
			}
			else
				body = 0;
		}
		else
		{
	                //Message[u].assign(INPUT);
			Message += INPUT + "\n";
        	        u++;
		} 	
		c++; // next line.
	}

	pr("check for html mail");	
	// now we do have the whole body, but what if the body is a multipart message?
	if(bound != "")
	{
		Temp = Message;
		Message = "";
		string tag(""), Html_Message("");
		string::size_type pos_;
		match = 0;
		int firstspc=0;
		body =0;
		u = Temp.length();
		string bad_tags[12];
		bad_tags[0] = "<html>";
		bad_tags[1] = "<HTML>";
		bad_tags[2] = "</html>";
		bad_tags[3] = "</HTML>";
		bad_tags[4] = "<body>";
		bad_tags[5] = "<BODY>";
		bad_tags[6] = "</body>";
		bad_tags[7] = "</BODY>";
		bad_tags[8] = "<head>";
		bad_tags[9] = "<HEAD>";
		bad_tags[10] = "</head>";
		bad_tags[11] = "</HEAD>";
		for(i=0;i<u;i++)
		{
			if((Temp[i] == '\n') && (match != yes))
			{
				if(UseHTML != yes)
					_pos = line.find("Content-Type: text/plain");
				else
					_pos = line.find("Content-Type: text/html");
				if(_pos != string::npos)
				{
					match = yes;
					if(UseHTML == yes)
						IsHTML = yes;
					else
						IsHTML = 0;	
				}
				line = "";
			}
			else if((Temp[i] == '\n') && (match == yes))
			{
				_pos = line.find("quoted-printable");
				if(_pos != string::npos)
					quoted = yes;
				if((line == "") && (firstspc != yes))
					firstspc = yes;
				if(firstspc == yes)
				{
					pos_ = line.find(bound);
					if(pos_ != string::npos)
					{
						break;
					}
					else
					{
						Message += line + "\n";
					}
				}
				line = "";	
			}
			else
				line += Temp[i];
		}
		if(quoted == yes)
		{
			pr("MIME, quoted-printable");
			Temp = "";
			Temp = quoted2html(Message);
			Message = "";
		}
		else
		{
			pr("MIME, NOT quoted-printable");
			Temp = "";
			Temp = Message;
			Message = "";
		}
		quoted = 0; // reset quoted.
		pr(Temp);
		u = Temp.length();
		line = "";
		// and now strip dagerous html code:
		for(i=0;i<u;i++)
		{
			if(Temp[i] == '\n')
			{
				cou = line.length();
                                body = yes;
                                for(int p=0;p<cou;p++)
                                {
                                        if((line[p] == '<') || (body != yes))
                                        {
                                                body = 0;
                                                tag += line[p];
                                                if(line[p] == '>')
                                                {
                                                       for(int ds=0; ds<12;ds++)
                                                       {
                                                              if(tag == bad_tags[ds])
                                                              {
								     if((ds > 7) && (ds < 10))
								     {
									// <head> found
									head = "start";
									pr("<head> found");
								     }
								     else if(ds > 9)
								     {
									// </head> found
									head = "end";
									pr("</head> found");
								     }
                                                                     tag = "";
                                                                     break;
                                                              }
                                                              else
                                                              {
                                                                     _pos = tag.find("<body");
                                                                     pos_ = tag.find("<BODY");
								     head_ = tag.find(bad_tags[10]);
								     _head = tag.find(bad_tags[11]);	
                                                                     if((_pos != string::npos) || (pos_ != string::npos))
                                                                     {
                                                                              tag = "";
                                                                              break;
                                                                     }
								     else if((head_ != string::npos) || (_head != string::npos))
								     {
									      head = "end";
									      pr("</head> found");
									      tag = "";
									      break;
								     }
                                                              }
                                                        }
							// if nothing dangerous found and if we are not into a <head> sector
							// add the tag to the resulting body, even if it is html.
                                                        if((tag != "") && (head == ""))
                                                        {
							      pr("tag:" + tag);
                                                              Message += tag;
                                                              tag = "";
                                                        }
							else
							{
								// nothing appended, mark this state, so line 803 will not match!
								doitnot = yes;
							}
							if(head == "end")
								head = "";
                                                }
                                         }
                                         else
					 {
                                               	Message += line[p];
					 }
                                }
				if(doitnot != yes)
                                {
					Message += "\n";
				}					
				doitnot = 0;	
				line = "";
			}
			else
				line += Temp[i];
		}
	}
	else
	{
		// not a MIME message
		// but perhaps quoted-printable formatted?
		if(quoted == yes)
		{
			pr("Plain, quoted-printable");
			Temp = "";
			Temp = Message;
			Message = "";
			Message = quoted2html(Temp);
		}
		// It's not HTML:
		IsHTML = 0;
	}


	
	// now we have all values we need, let's check them...
	// read the Allow file
	match = 0; // we reuse match here, don't wonder :-)

	// check, if specified, who is allowed to use
	if(Allow_From != ".everybody")
	{
		pr("check Allow_From");
		ifstream Allow(Allow_From.c_str());
		if( ! Allow )
		{
			err_msg = "Error: Could not read ";
			err_msg.append(Allow_From);
			err_msg.append("\n");
			err("Standard", err_msg, ADMIN);
		}
		else
		{
			while( Allow )
			{
				Allow.getline(TMP, MAX);
				COMP = TMP;
			        if(COMP != "")
				{
					_pos = FROM.find(COMP);
					if( _pos == string::npos )
					{
	                	                // we didn't find FROM in the current line
      		                  	        // if we found a match in an earlier line
 		                               // let's match stay tuned.
        		                        if(match == 1)
        	        	                        match = 1;
        	                	        else
        	                        	        match = 0;
					}
					else
					{
		                        	// we found him !
	        	                        match = 1;
					}
				}
			}
			// cout << "MATCH " << match << endl;	
			if(match == 0)
			{	
				err_msg = "Error: ";
				err_msg.append(FROM);
				err_msg.append(" is not a valid user.\n");
				err(Orig_MSG, err_msg, ADMIN);
			}
			else
				_true = 1;
		}
	}

	
	// check, if specified, the auth code from the subject line:
	if(AUTH_CODE != "")
	{
		pr("check AUTH_CODE");
		_pos = SUBJECT.find(AUTH_CODE);
		if( _pos != string::npos )
		{
			// Yeah! The AUTH_CODE was found in the Subject line!
			_true = 2;
		}
		else
		{
			// No, wrong AUTH_CODE.
			_true = 1;
		}
	}
	else
		_true = 2;	 


     } // end of "if(cron != yes)" !
     else
	_true = 2; // set _true to 2, so processing will be started!	



 	if(_true == 2)
	{
		// ********************************** Storage starts here! ******************************
		// create a response message, if it is not in cron mode:
	    if(cron != yes)
	    {
		pr("prepare response message");
                CMD.append("(echo \"From: ");
                CMD.append(SENDER);
                CMD.append("\"; echo \"To: ");
		if(TO != ".mailfrom")
		{
                	CMD.append(TO);
		}
		else
		{
			CMD.append(FROM);
		}
		UseFrom = FROM;
                CMD.append("\"; echo \"Cc: ");
                CMD.append(CC);
                CMD.append("\"; echo \"Subject: ");
		if(AUTH_CODE != "")
		{
                	if(SUBJECT.length() <= AUTH_CODE.length())
                	{
                	        // Subject without the code was empty
                	        err(Orig_MSG, "Error: Subject Line was empty after cutting AUTH_CODE\n", ADMIN);
                	}
                	else
                	{
				CMD.append("htnews item inserted: '");
				// TTT
				Temp = "";
				Temp.append(SUBJECT, AUTH_CODE.length());
                	        //CMD.append(SUBJECT, AUTH_CODE.length());
				CMD.append(replace(Temp));
				CMD.append("'");
				UseSubject.append(SUBJECT, AUTH_CODE.length());
                	}
		}
		else
		{
			if(SUBJECT == "")
				err(Orig_MSG, "Error: Subject Line was empty\n", ADMIN);
			else
			{
				CMD.append("htnews item inserted: '");
				CMD.append(replace(SUBJECT));
				CMD.append("'");
				UseSubject = SUBJECT;
			}
		}
		if(UseSubject == "refresh" || UseSubject == " refresh")
		{
			_pos = FROM.find(ADMIN);
			if( _pos != string::npos )
				refresh = yes;
			else
				err("refresh-error","Error. You are not allowed to use the \"refresh\" keyword\n",ADMIN);
		}
                CMD.append("\"; echo \"");
		CMD.append("The following message was inserted:\n\n");
		CMD.append(replace(Message));
		CMD.append("\") | " + string(_SENDMAIL) + " -t");
		

		Store.open(STORE.c_str(), ios::out | ios::in);
                if( ! Store )
                        err("Standard", "Error: Could not open " + STORE + "\n", ADMIN);


		if(ARCHIV == "YES")
		{
			Archiv_Store.open(Archiv_STORE.c_str(), ios::out | ios::in);
			if( ! Archiv_Store )
				err("Standard", "Error: Could not open " + Archiv_STORE + "\n", ADMIN);
		}




		// ***************** store the new item to the top of the storage file! ************


		if(refresh != yes)
                {
			pr("get old items");
			// get old items, and count number of items (for archieving)		
			while(ReStore)
               		{
               		        ReStore.get(zeichen);
				if(zeichen == '\n')
				{
				   if(ARCHIV == "YES")
				   {
					/*
					_pos = line.find("%htnews_end");
                                        if( _pos != string::npos )
                                                NumItems++;
					*/
					if(NumItems >= MAXITEMS - 1)
					{
						//cat to NewAString
						NewAString += line + "\n";
					}
					else
					{
						T += line + "\n";
					}
				   	_pos = line.find("%htnews_end");
				   	if( _pos != string::npos )
						NumItems++;
				   }
				   else
				   	T += line + "\n";
				   line = "";
				}
				else
               		        	line += zeichen;
               		}
			ReStore.close();

			pr("get date from system");
		        time_t t;
	       		time(&t);
	        	string Zeit;
	        	Zeit = ctime(&t);
			/*
			 * obsolete
	        	#if defined _EGCS
	        	  UseDate = Zeit.erase(24); 
	        	#else
	        	  UseDate = Zeit.remove(24);
	        	#endif
			*/
			int Zeitlen = Zeit.length();
			UseDate.assign(Zeit, 0, Zeitlen-1);
			string Command("echo \"\" > ");
			Command += STORE;
			system(Command.c_str());			
	
			pr("write data");	
			// write the nes data to Store
			Store << "\n%From: " << UseFrom;
			Store << "\n%Subject: " << UseSubject;
			Store << "\n%Date: " << UseDate;
			Store << "\n%Message-ID: " << MessageID;
			Store << "\n%Message: " << Message << "\n%htnews_end\n\n";
			// append the old data to Store
			Store << T;
			T = "";
			Store.seekg(0);
			
			/*
			 * Now we have all data together in our Storage file, this should 
			 * look like this:
			 * 
			 * %From: "User" <user@foo.bar>
			 * %Subject: Something new
			 * %Date: 12.12.1999
			 * %Message: Hello, this is an example message,
			 * and it can consist of more than one line.
			 * %htnews_end
			 *
			 */
			if(ARCHIV == "YES")
			{
				// save the origin Archiv_Store data...
				T = "";
				while( Archiv_ReStore )
				{
					Archiv_ReStore.get(zeichen);
					T += zeichen;
				}
				Archiv_ReStore.close();
				// Now first write NewAString and then T to Archiv_Store:
				Archiv_Store << NewAString << T;
				Archiv_Store.seekg(0);
				Archiv_Store.close(); 
				NewAString = "";
			}
		}
		T = "";
// bis hierhin OK!


	   } // end of cron check



	
		string ItemArray[6], EmailTemp(""), RealName, RealAdress;
		buffer = "";
		int MsgState=0, CanStart=0, CanArch=0;


/* obsolete
		int NumStoreLines=0;
		// try to count the number of lines in Store.
		while( Store )
		{
			Store.get(zeichen);
			if(zeichen == '\n')
				NumStoreLines++;
		}
*/

		if(cron != yes)
		{
			Store.seekg(0);
			Store.close();
		}

		pr("open temp files for formated output");
		// Now format every item and store it to StoreTmp


		ofstream StoreOut;
		string StoreTmp("/tmp/htnews.storetmp");
	    if(cron != yes)
	    {	
		StoreOut.open(StoreTmp.c_str());
		if( ! StoreOut )
			err("Standard", "Error: Could not open " + StoreTmp + "\n", ADMIN);
	    } // end of cron



		ofstream Archiv_Temp(Archiv_TEMP.c_str());


		//************************************************************************************
		// 792: Pointer to ifstream!
		pr("open pointer to ifstream Storage");
		ifstream *Storage;

	   if(cron != yes)
	   {	
		Storage = new ifstream(STORE.c_str());
		if( ! *(Storage) )
			err("Standard", "Error: ptr, Could not open " + STORE + "\n", ADMIN);
	   } // end of cron
	   else
	   {
		Storage = new ifstream(Archiv_STORE.c_str());
		if( ! *(Storage) )
			err("Standard", "Error: ptr, Could not open " + Archiv_STORE + "\n", ADMIN);
	   } // end of cron

	

		for(CanArch=0;CanArch<2;CanArch++)
		{
		   if(cron == yes)
			CanArch = yes; // end of cron

		   pr("processing stored data...");
		   while( *(Storage) )
		   {
			Storage->get(zeichen);
			if(zeichen == '\n')
			{
				if(MsgState != 0)
				{
					if(buffer == "%htnews_end")
					{
						// ItemArray[4] (Message) is complete
						MsgState = 0;
	
						// Item is complete, we can start formatting.
						CanStart = 1;
						ItemArray[subject] = "";
						if((DetailLink == "Subject") && (ItemArray[messageid] != "") && (HaveDetail == yes))
						{	
							ItemArray[subject] += Detail_HEAD;
                                                	ItemArray[subject] += "<a href=\"";
							ItemArray[subject] += DetailURL;
                                                	ItemArray[subject] += ItemArray[messageid];
                                                	ItemArray[subject] += ".html\">";
	                                                ItemArray[subject] += SimpleSubject;
	                                                ItemArray[subject] += "</a>";
	                                                ItemArray[subject] += Detail_FOOT + "\n";
						}					
						else
							ItemArray[subject] += SimpleSubject;	
					}
					else
					{
						if(((LookDetail == yes) && (buffer == "<!--detail-->")) || (HaveDetail == yes))
						{
							if(ItemArray[messageid] == "")
							{
								HaveDetail = 0;
								break;
							}
							else
							{
								HaveDetail = yes;
								if((buffer == "<!--detail-->") && (DetailLink != "Subject"))
								{
									ItemArray[message] += Detail_HEAD;
									ItemArray[message] += "<a href=\"";
									ItemArray[message] += DetailURL;
									ItemArray[message] += ItemArray[messageid];
									ItemArray[message] += ".html\">" + DetailLink;
									ItemArray[message] += "</a>"; 
									ItemArray[message] += Detail_FOOT + "\n";
								}
								// CRLF
								if((CRLF == "YES") && (IsHTML != yes))
									DetailMSG += htmlize(buffer);
								else
									DetailMSG += buffer + "\n";	
							}
						}
						else	
						{
							if((CRLF == "YES") && (IsHTML != yes))
								ItemArray[message] += htmlize(buffer);
							else
								ItemArray[message] += buffer + " \n"; // CRLF
						}
					}
				}
				else
				{
				  _pos = buffer.find("%From:");
				  if( _pos != string::npos )
				  {
					EmailTemp = "";
					EmailTemp.assign(buffer, _pos+6);
				  }
				  else
				  {
					_pos = buffer.find("%Subject:");
					if( _pos != string::npos )
					{
						SimpleSubject = "";
						SimpleSubject.assign(buffer, _pos+9);
					}
					else
					{
						_pos = buffer.find("%Date:");
						if( _pos != string::npos )
						{
							ItemArray[date] = "";
							ItemArray[date].assign(buffer,_pos+6);
						}
						else
						{
							_pos = buffer.find("%Message-ID:");
							if( _pos != string::npos )
							{
								ItemArray[messageid] = "";
								ItemArray[messageid].assign(buffer, _pos+13);
							}
							else
							{
							  _pos = buffer.find("%Message:");
							  if( _pos != string::npos )
							  {
								ItemArray[message] = "";
								if((CRLF == "YES") && (IsHTML != yes))
								{
									string crlftemp("");
									crlftemp.assign(buffer,_pos+10);
									ItemArray[message] += htmlize(crlftemp);
									crlftemp = "";
								}
								else
								{
									ItemArray[message].assign(buffer,_pos+10);
									ItemArray[message] += " \n";
								}
								MsgState = 1;
							  }
							}	
						}
					}
				  } 
				}
				if(CanStart == 1)
				{
					// Before we begin, let's parse the From line!
					// most likely it looks like this:
					// "Real Name" <user@foo.bar>
					int p, adrmode, cc;
					st = EmailTemp.length();
					ItemArray[realname] = "";
					ItemArray[adress] = "";
					adrmode = 0;
					string protected_adress(""), protmp("");
					string DetailTemp("");
					
					for(p=0;p<st;p++)
					{
						if(EmailTemp[p] == '"')
							adrmode=0;
						else if(EmailTemp[p] == '<')
							adrmode = 1;	
						else if(EmailTemp[p] == '>')
							break;
						else if(adrmode == 1)
							ItemArray[adress] += EmailTemp[p];
						else
							ItemArray[realname] += EmailTemp[p];
					}
					
					if(SPAMPROTECT == "YES")
					{
						protmp = ItemArray[adress];
						ItemArray[adress] = "";
						cc = protmp.length();
						for(p=0;p<cc;p++)
						{
							if(protmp[p] == '@')
								ItemArray[adress] += " @ ";
							else
								ItemArray[adress] += protmp[p];
						}
					}
					

					/*
					 * ok, what do we have actually?
					 * ItemArray[realname] = Real Name
					 * ItemArray[adress] = Email adress
					 * ItemArray[subject] = Subject
					 * ItemArray[date] = Date
					 * ItemArray[messageid] = Message-ID
					 * ItemArray[message] = Message
					 */
					if(CanArch == yes)
					  Archiv_Temp << ITEM_HEAD << "\n";
					else	
					  StoreOut << ITEM_HEAD << "\n";
					if(HaveDetail == yes)
					  DetailTemp += ITEM_HEAD + "\n";	
					for(p=0;p<FieldMax+1;p++)
					{
						if(FieldOrder[p] == "Date")
						{
							if(CanArch == yes)
							  Archiv_Temp << Date_HEAD << ItemArray[date] << Date_FOOT << endl;
							else		  
							  StoreOut << Date_HEAD << ItemArray[date] << Date_FOOT << endl;
							if(HaveDetail == yes)
							  DetailTemp += Date_HEAD + ItemArray[date] + Date_FOOT + "\n";
						}
						else if(FieldOrder[p] == "Subject")
						{
							if(CanArch == yes)
							  Archiv_Temp << Subject_HEAD << ItemArray[subject] << Subject_FOOT << endl;
							else
							  StoreOut << Subject_HEAD << ItemArray[subject] << Subject_FOOT << endl;
							if(HaveDetail == yes)
							  DetailTemp += Subject_HEAD + SimpleSubject + Subject_FOOT + "\n";
						}
						else if(FieldOrder[p] == "From")
						{
							if(CanArch == yes)
								Archiv_Temp << From_HEAD;
							else
								StoreOut << From_HEAD;
							if(HaveDetail == yes)
								DetailTemp += From_HEAD;
							if(Mailto == "YES")
							{
								if(CanArch == yes)
								{
								  Archiv_Temp << "<A HREF=\"mailto:" << ItemArray[adress] << "\">";
                                                                  if(ItemArray[realname] == "")
                                                                          Archiv_Temp << ItemArray[adress];
                                                                  else
                                                                          Archiv_Temp << ItemArray[realname];
                                                                  Archiv_Temp << "</A>";
								}
								else
								{
								  StoreOut << "<A HREF=\"mailto:" << ItemArray[adress] << "\">";
								  if(ItemArray[realname] == "")
								     	  StoreOut << ItemArray[adress];
								  else
									  StoreOut << ItemArray[realname];
								  StoreOut << "</A>";
								}
								if(HaveDetail == yes)
								{
								  DetailTemp += "<A HREF=\"mailto:" + ItemArray[adress] + "\">";
								  if(ItemArray[realname] == "")
									  DetailTemp += ItemArray[adress];
								  else
									  DetailTemp += ItemArray[realname];
								  DetailTemp += "</A>";
								}
							}
							else
							{
								if(CanArch == yes)
								{
								  if(ItemArray[realname] == "")
                                                                          Archiv_Temp << ItemArray[adress];
                                                                  else
                                                                          Archiv_Temp << ItemArray[realname];
								}
								else
								{
								  if(ItemArray[realname] == "")
                                                                          StoreOut << ItemArray[adress];
                                                                  else
                                                                          StoreOut << ItemArray[realname];
								}
								if(HaveDetail == yes)
								{
								  if(ItemArray[realname] == "")
                                                                          DetailTemp += ItemArray[adress];
                                                                  else
                                                                          DetailTemp += ItemArray[realname];
								}		
							}
							if(CanArch == yes)
								Archiv_Temp << From_FOOT << endl;
							else
								StoreOut << From_FOOT << endl;
							if(HaveDetail == yes)
								DetailTemp += From_FOOT + "\n";
						}
						else if(FieldOrder[p] == "Text")
						{
							if(CanArch == yes)
								Archiv_Temp << Text_HEAD << ItemArray[message] << Text_FOOT << endl;
							else
								StoreOut << Text_HEAD << ItemArray[message] << Text_FOOT << endl;
							if(HaveDetail == yes)
							{
								DetailTemp += Text_HEAD + DetailMSG + Text_FOOT + "\n";
								DetailMSG = "";
							}
						}
					}
					if(CanArch == yes)
						Archiv_Temp << ITEM_FOOT << "\n\n";
					else
						StoreOut << ITEM_FOOT << "\n\n";
					if(HaveDetail == yes)
						DetailTemp += ITEM_FOOT + "\n";
					// we are ready with this item, let's go to the next:
					CanStart = 0;
					
					// start to create the Detail file
					if(HaveDetail == yes)
					{
						HaveDetail = 0;	
						Detail_Templ.open(DetailTemplate.c_str());
						DetailName = DetailPATH + "/" + ItemArray[messageid] + ".html";
						Detail = new ofstream(DetailName.c_str());
						if( ! *Detail )
						{
							err("Standard","Error: Could not open \"" + DetailName + "\"\n", ADMIN);
						}
						buffer = "";
						while(Detail_Templ)
                				{
                        			Detail_Templ.get(zeichen);
                        			if(zeichen == '\n')
                        			{
							if(buffer == "<!--title-->")
							{
								*Detail << SimpleSubject << endl;
							}
                                			if((buffer == htnews_marker[0]) || (buffer == htnews_marker[1]))
                                			{
                                        			*Detail << DetailTemp;
                                			}
                                			else
                                        			*Detail << buffer << endl;
                                			buffer = "";
                        			}
                        			else
                                			buffer += zeichen;
                				}// while end
						Detail_Templ.seekg(0);
						Detail_Templ.close();
						Detail->close();
						delete Detail;
						DetailTemp = "";
					}
				}
			buffer = "";
			}
			else
				buffer += zeichen;
		   }
		   // end or one for loop !
		   if((ARCHIV == "YES") && (cron != yes))
		   {
			Storage->close();
			delete Storage;
			Storage = new ifstream(Archiv_STORE.c_str());
		   }
		   else
			break;
		}
		Storage->close();
		delete Storage;

		if(cron != yes)
			StoreOut.close(); // end of cron

		Archiv_Temp.close();
		// ************************* Temp file with results ready ***********************

		// insert the formatted items to the resulting page using the template

		pr("open the template");	

		
		ifstream Temp(StoreTmp.c_str());
		
	     if(cron != yes)
	     {	
		while(Temp)
		{
			Temp.get(zeichen);
			T += zeichen;
		}
	     }	

		ofstream Archiv_Output;
		if((ARCHIV == "YES") || (cron == yes))
		{
			ifstream ATemp(Archiv_TEMP.c_str());
			while(ATemp)
			{
				ATemp.get(zeichen);
				NewAString += zeichen;
			}
			if(cron == yes)
			{
				Archiv_Output.open(Cron_OUTPUT.c_str());
				if( ! Archiv_Output )
					err("Standard","Cron-Error: Could not open " + Cron_OUTPUT + ".\n",ADMIN);
			}
			else
			{
				Archiv_Output.open(Archiv_OUTPUT.c_str());
				if( ! Archiv_Output )
					err("Standard","Cron-Error: Could not open " + Archiv_OUTPUT + ".\n",ADMIN);	
			}
		}

		// pr("try to open the resulting page");
		// ofstream Output(OUTPUT.c_str());

	     if(cron != yes)
	     {
		pr("try to open the resulting page");
                ofstream Output(OUTPUT.c_str());
		if( ! Output )
               		err("Standard", "Error: Could not open " + OUTPUT + "\n", ADMIN);	
		pr("write data from temp to result");
                while(Template)
                {
                        Template.get(zeichen);
                        if(zeichen == '\n')
                        {
                                if((buffer == htnews_marker[0]) || (buffer == htnews_marker[1]))
                                {
					//cout << T << endl;
					Output << T;
				}
				else        
					Output << buffer << endl;
				buffer = "";
                        }
                        else
                                buffer += zeichen;      
                }
	    }



		if(cron == yes)
                {
			// build cron for one month
                        buffer = "";
                        while(Archiv_Template)
                        {
                                Archiv_Template.get(zeichen);
                                if(zeichen == '\n')
                                {
					if(buffer == "<!--title-->")
					{
						Archiv_Output << Archiv_Title_Head;
						Archiv_Output << Month;
						Archiv_Output << Archiv_Title_Foot;
					}
                                        if((buffer == archiv_marker[0]) || (buffer == archiv_marker[1]))
                                        {
                                                        Archiv_Output << NewAString;
                                        }
                                        else
                                        {
                                                Archiv_Output << buffer << endl;
                                        }
                                        buffer = "";
                                }
                                else
                                        buffer += zeichen;
                        }
			
			buffer = "";
			// the place where we build CronLinks
			if(CronLinks != "")
			{
			  HistoryIn.open(Cron_Hist.c_str(), ios::in);
			  HistoryIn.seekg(0);
			  CronLinks = "";			
			  while(HistoryIn)
			  {
				HistoryIn.get(zeichen);
				if(zeichen == '\n')
				{
					if(buffer == (Month + ".html"))
					{
						HaveCron = yes; // there is already a file for the current Month!
						break;
					}
					else if(buffer != "")
					{
						CronLinks += buffer + "\n";
					}
					buffer = "";
				}
				else
					buffer += zeichen;
			  }
			} 
			HistoryIn.seekg(0);
			HistoryIn.close();
			if(HaveCron != yes)
			{
				HistoryOut.open(Cron_Hist.c_str());
				HistoryOut << CronLinks << Month << ".html\n";
			}
			else
			{
				// Archiving for current month allready done!
				cout << "Error: " << Month << ".html exists! Processing complete!\n";
				Exit();
			}
			//HistoryOut.seekg(0);
			HistoryOut.close();
			CronLinks = "";
                }


		if(ARCHIV == "YES")
		{
			// build archiv
			//Archiv_Output.seekg(0);
			Archiv_Output.close();
			Archiv_Output.open(Archiv_OUTPUT.c_str());
			//Archiv_Template.seekg(0);
			Archiv_Template.close();
			Archiv_Template.open(Archiv_TEMPLATE.c_str());
			buffer = "";
			while(Archiv_Template)
			{
				Archiv_Template.get(zeichen);
				if(zeichen == '\n')
				{
					if((buffer == archiv_marker[0]) || (buffer == archiv_marker[1]))
					{
						if(cron != yes)
							Archiv_Output << NewAString;
					}
					else if(buffer == cron_marker)
					{
						// add the link(s) to the older pages to the archiv page!
						buffer = "";
						HistoryIn.close();
						HistoryIn.open(Cron_Hist.c_str(), ios::in);
						HistoryIn.seekg(0);
						zeichen = 0;
						while(HistoryIn)
						{
							HistoryIn.get(zeichen);
							if(zeichen == '\n')
							{
								pr("Processing" + buffer);
								Archiv_Output << Cron_HEAD;
								Archiv_Output << "<a href=\"" << buffer << "\">" << buffer << "</a>";
								Archiv_Output << Cron_FOOT;
								buffer = "";
							}
							else
							{	
								buffer += zeichen;
							}	
						}
					}		
					else
					{
						Archiv_Output << buffer << endl;
					}
					buffer = "";
				}
				else
					buffer += zeichen;
			}
		}
		if(refresh == yes)
			err("refresh", OUTPUT + "htnews has been updated using " + parse_config + "\n",ADMIN);

		pr("remove temp files");
		// remove any temp filez...
		system("rm /tmp/htnews.*");

		pr("send response message");
		if((refresh != yes) && (cron != yes) && (TO != "/dev/null"))
                        system(CMD.c_str());

		if(cron == yes)
		{
			CMD = "";
			CMD = "echo \"\" > " + Archiv_STORE;
			system(CMD.c_str()); // remove all data from old archive!
		}
		pr("exit");
		Exit();
	}
	else
	{
		err(Orig_MSG,"Error: The Authentication Code did not match.\n", ADMIN);
	}	
}	
